﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        byte[] sendData = new byte[1];
        int gxX, gyX, gxY, gyY, count, i, j;
        int flag1  = 0;
        int adX, adY;
        string path;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            serialPort1.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (flag1 == 0)
            {
                try
                {
                    serialPort1.PortName = textBox2.Text;
                    serialPort1.Close();
                    serialPort1.Open();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(Convert.ToString(ex));
                    return;
                }
                button1.BackColor = Color.Tomato;
                button1.Text = "STOP";
                flag1 = 1;
                this.backgroundWorker1.RunWorkerAsync();
            }
            else
            {
                button1.BackColor = Color.Lime;
                button1.Text = "START";
                flag1 = 0;
                this.backgroundWorker1.CancelAsync();
            }
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            if (radioButton1.Checked == true)
            {
                sendData[0] = 0x50;
            }
            else
            {
                sendData[0] = 0x60;
            }
            if (checkBox1.Checked == true)
            {
                sendData[0] += 0x01;
            }
            if (checkBox2.Checked == true)
            {
                sendData[0] += 0x02;
            }
            gxX = 0; gyX = 0; gxY = 0; gyY = 0; count = 0;
            Graphics g = pictureBox1.CreateGraphics();
            g.Clear(Color.Black);
            for (i = 32; i <= 960; i += 64)
            {
                g.DrawLine(Pens.Green, i, 0, i, 512);
            }
            for (j = 0; j <= 512; j += 64)
            {
                g.DrawLine(Pens.Green, 0, j, 960, j);
            }
            for (i = 0; i <= 960; i += 16)
            {
                g.DrawLine(Pens.Green, i, 253, i, 259);
            }
            for (j = 0; j <= 512; j += 16)
            {
                g.DrawLine(Pens.Green, 477, j, 483, j);
            }
            path = textBox1.Text;
            System.IO.StreamWriter textFile;
            if (checkBox3.Checked == true)
            {
                textFile = System.IO.File.CreateText(path);
            }
            else
            {
                textFile = System.IO.File.AppendText(path);
            }
            textFile.Write(Convert.ToString(DateTime.Now)); textFile.Write(Environment.NewLine);
            textFile.Write("ECG"); textFile.Write(',');
            textFile.Write("HRT"); textFile.Write(Environment.NewLine);
            serialPort1.Write(sendData, 0, 1);
            while (backgroundWorker1.CancellationPending == false)
            {
                try
                {
                    if (serialPort1.ReadByte() == 255)
                    {
                        if (serialPort1.ReadByte() == 255)
                        {
                            adX = serialPort1.ReadByte() + serialPort1.ReadByte() * 256;
                            g.DrawLine( Pens.OrangeRed, gxX, 511 - gyX / 2, gxX + 1, 511 - adX / 2);
                            gxX++; gyX = adX;
                            textFile.Write(Convert.ToString(adX)); textFile.Write(',');
                            adY = serialPort1.ReadByte() + serialPort1.ReadByte() * 256;
                            g.DrawLine(Pens.DodgerBlue, gxY, 511 - gyY / 2, gxY + 1, 511 - adY / 2);
                            gxY++; gyY = adY;
                            textFile.Write(Convert.ToString(adY)); textFile.Write(Environment.NewLine);
                            count++;
                            if (count >= 960)
                            {
                                gxX = 0; gxY = 0; count = 0;
                                g.Clear(Color.Black);
                                for (i = 32; i <= 960; i += 64)
                                {
                                    g.DrawLine(Pens.Green, i, 0, i, 512);
                                }
                                for (j = 0; j <= 512; j += 64)
                                {
                                    g.DrawLine(Pens.Green, 0, j, 960, j);
                                }
                                for (i = 0; i <= 960; i += 16)
                                {
                                    g.DrawLine(Pens.Green, i, 253, i, 259);
                                }
                                for (j = 0; j <= 512; j += 16)
                                {
                                    g.DrawLine(Pens.Green, 477, j, 483, j);
                                }
                            }
                        }
                    }
                }
                catch (Exception ey)
                {
                    MessageBox.Show(Convert.ToString(ey));
                }
            }
            textFile.Close(); e.Cancel = true;
        }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            sendData[0] = 0;
            serialPort1.Write(sendData, 0, 1);
            while(serialPort1.BytesToWrite != 0) { }
            serialPort1.Close();
        }
    }
}
